Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4440)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4441)
@@ -22,5 +22,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
 !
 ! Former revisions:
@@ -3533,5 +3534,5 @@
 !
 !--    Get land use for i,j and assign to DEPAC lu
-       IF ( surf_lsm_h%frac(ind_veg_wall,m) > 0 )  THEN
+       IF ( surf_lsm_h%frac(m,ind_veg_wall) > 0 )  THEN
           luv_palm = surf_lsm_h%vegetation_type(m)
           IF ( luv_palm == ind_luv_user )  THEN
@@ -3577,5 +3578,5 @@
        ENDIF
 
-       IF ( surf_lsm_h%frac(ind_pav_green,m) > 0 )  THEN
+       IF ( surf_lsm_h%frac(m,ind_pav_green) > 0 )  THEN
           lup_palm = surf_lsm_h%pavement_type(m)
           IF ( lup_palm == ind_lup_user )  THEN
@@ -3615,5 +3616,5 @@
        ENDIF
 
-       IF ( surf_lsm_h%frac(ind_wat_win,m) > 0 )  THEN
+       IF ( surf_lsm_h%frac(m,ind_wat_win) > 0 )  THEN
           luw_palm = surf_lsm_h%water_type(m)     
           IF ( luw_palm == ind_luw_user )  THEN
@@ -3675,5 +3676,5 @@
 !
 !--    Vegetation
-       IF ( surf_lsm_h%frac(ind_veg_wall,m) > 0 )  THEN
+       IF ( surf_lsm_h%frac(m,ind_veg_wall) > 0 )  THEN
 
 !
@@ -3812,5 +3813,5 @@
 !
 !--    Pavement
-       IF ( surf_lsm_h%frac(ind_pav_green,m) > 0 )  THEN
+       IF ( surf_lsm_h%frac(m,ind_pav_green) > 0 )  THEN
 !
 !--       No vegetation on pavements:
@@ -3939,5 +3940,5 @@
 !
 !--    Water
-       IF ( surf_lsm_h%frac(ind_wat_win,m) > 0 )  THEN
+       IF ( surf_lsm_h%frac(m,ind_wat_win) > 0 )  THEN
 !
 !--       No vegetation on water:
@@ -4073,7 +4074,7 @@
        DO  lsp = 1, nspec
 
-          bud(lsp) = surf_lsm_h%frac(ind_veg_wall,m) * bud_luv(lsp) + &
-               surf_lsm_h%frac(ind_pav_green,m) * bud_lup(lsp) + &
-               surf_lsm_h%frac(ind_wat_win,m) * bud_luw(lsp)
+          bud(lsp) = surf_lsm_h%frac(m,ind_veg_wall) * bud_luv(lsp) + &
+               surf_lsm_h%frac(m,ind_pav_green) * bud_lup(lsp) + &
+               surf_lsm_h%frac(m,ind_wat_win) * bud_luw(lsp)
 !
 !--       Compute new concentration:
@@ -4121,5 +4122,5 @@
 !
 !--    Get land use for i,j and assign to DEPAC lu
-       IF ( surf_usm_h%frac(ind_pav_green,m) > 0 )  THEN
+       IF ( surf_usm_h%frac(m,ind_pav_green) > 0 )  THEN
 !
 !--       For green urban surfaces (e.g. green roofs
@@ -4168,5 +4169,5 @@
        ENDIF
 
-       IF ( surf_usm_h%frac(ind_veg_wall,m) > 0 )  THEN
+       IF ( surf_usm_h%frac(m,ind_veg_wall) > 0 )  THEN
 !
 !--       For walls in USM assume concrete walls/roofs,
@@ -4210,5 +4211,5 @@
        ENDIF
 
-       IF ( surf_usm_h%frac(ind_wat_win,m) > 0 )  THEN
+       IF ( surf_usm_h%frac(m,ind_wat_win) > 0 )  THEN
 !
 !--       For windows in USM assume metal as this is
@@ -4295,5 +4296,5 @@
 !
 !--    Walls/roofs
-       IF ( surf_usm_h%frac(ind_veg_wall,m) > 0 )  THEN
+       IF ( surf_usm_h%frac(m,ind_veg_wall) > 0 )  THEN
 !
 !--       No vegetation on non-green walls:
@@ -4426,5 +4427,5 @@
 !
 !--    Green usm surfaces
-       IF ( surf_usm_h%frac(ind_pav_green,m) > 0 )  THEN
+       IF ( surf_usm_h%frac(m,ind_pav_green) > 0 )  THEN
 
 !
@@ -4564,5 +4565,5 @@
 !
 !--    Windows
-       IF ( surf_usm_h%frac(ind_wat_win,m) > 0 )  THEN
+       IF ( surf_usm_h%frac(m,ind_wat_win) > 0 )  THEN
 !
 !--       No vegetation on windows:
@@ -4696,7 +4697,7 @@
 
 
-          bud(lsp) = surf_usm_h%frac(ind_veg_wall,m) * bud_luu(lsp) + &
-               surf_usm_h%frac(ind_pav_green,m) * bud_lug(lsp) + &
-               surf_usm_h%frac(ind_wat_win,m) * bud_lud(lsp)
+          bud(lsp) = surf_usm_h%frac(m,ind_veg_wall) * bud_luu(lsp) + &
+               surf_usm_h%frac(m,ind_pav_green) * bud_lug(lsp) + &
+               surf_usm_h%frac(m,ind_wat_win) * bud_lud(lsp)
 !
 !--       Compute new concentration
Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 4440)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 4441)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
 ! 
 ! Former revisions:
@@ -426,9 +427,9 @@
                       i                   = surf_usm_h%i(m)            
                       j                   = surf_usm_h%j(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%frac(ind_veg_wall,m)  *  &
+                      local_pf(i,j,nzb+1) = surf_usm_h%frac(m,ind_veg_wall)  *  &
                                             surf_usm_h%wghf_eb(m)        +      &
-                                            surf_usm_h%frac(ind_pav_green,m) *  &
+                                            surf_usm_h%frac(m,ind_pav_green) *  &
                                             surf_usm_h%wghf_eb_green(m)  +      &
-                                            surf_usm_h%frac(ind_wat_win,m)   *  &
+                                            surf_usm_h%frac(m,ind_wat_win)   *  &
                                             surf_usm_h%wghf_eb_window(m)
                    ENDDO
@@ -755,9 +756,9 @@
                       j   = surf_usm_h%j(m)
                       local_pf(i,j,nzb+1) =                                          &
-                                 ( surf_usm_h%frac(ind_veg_wall,m)  *                &
+                                 ( surf_usm_h%frac(m,ind_veg_wall)  *                &
                                    surf_usm_h%r_a(m)       +                         & 
-                                   surf_usm_h%frac(ind_pav_green,m) *                &
+                                   surf_usm_h%frac(m,ind_pav_green) *                &
                                    surf_usm_h%r_a_green(m) +                         & 
-                                   surf_usm_h%frac(ind_wat_win,m)   *                &
+                                   surf_usm_h%frac(m,ind_wat_win)   *                &
                                    surf_usm_h%r_a_window(m) )
                    ENDDO
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 4440)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 4441)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
 ! 
 ! Former revisions:
@@ -1089,11 +1090,11 @@
                       m = surf_def_h(0)%start_index(j,i)
                       sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  +              &
-                                   surf_def_h(0)%rrtm_aldif(0,m) * rmask(j,i,sr)
+                                   surf_def_h(0)%rrtm_aldif(m,0) * rmask(j,i,sr)
                       sums_l(nzb,109,tn) = sums_l(nzb,109,tn)  +               &
-                                   surf_def_h(0)%rrtm_aldir(0,m) * rmask(j,i,sr)
+                                   surf_def_h(0)%rrtm_aldir(m,0) * rmask(j,i,sr)
                       sums_l(nzb,110,tn) = sums_l(nzb,110,tn)  +               &
-                                   surf_def_h(0)%rrtm_asdif(0,m) * rmask(j,i,sr)
+                                   surf_def_h(0)%rrtm_asdif(m,0) * rmask(j,i,sr)
                       sums_l(nzb,111,tn) = sums_l(nzb,111,tn)  +               &
-                                   surf_def_h(0)%rrtm_asdir(0,m) * rmask(j,i,sr)
+                                   surf_def_h(0)%rrtm_asdir(m,0) * rmask(j,i,sr)
                    ENDIF
                    IF ( surf_lsm_h%end_index(j,i) >=                           &
@@ -1101,15 +1102,15 @@
                       m = surf_lsm_h%start_index(j,i)
                       sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  +              &
-                               SUM( surf_lsm_h%frac(:,m) *                     &
-                                    surf_lsm_h%rrtm_aldif(:,m) ) * rmask(j,i,sr)
+                               SUM( surf_lsm_h%frac(m,:) *                     &
+                                    surf_lsm_h%rrtm_aldif(m,:) ) * rmask(j,i,sr)
                       sums_l(nzb,109,tn) = sums_l(nzb,109,tn)  +               &
-                               SUM( surf_lsm_h%frac(:,m) *                     &
-                                    surf_lsm_h%rrtm_aldir(:,m) ) * rmask(j,i,sr)
+                               SUM( surf_lsm_h%frac(m,:) *                     &
+                                    surf_lsm_h%rrtm_aldir(m,:) ) * rmask(j,i,sr)
                       sums_l(nzb,110,tn) = sums_l(nzb,110,tn)  +               &
-                               SUM( surf_lsm_h%frac(:,m) *                     &
-                                    surf_lsm_h%rrtm_asdif(:,m) ) * rmask(j,i,sr)
+                               SUM( surf_lsm_h%frac(m,:) *                     &
+                                    surf_lsm_h%rrtm_asdif(m,:) ) * rmask(j,i,sr)
                       sums_l(nzb,111,tn) = sums_l(nzb,111,tn)  +               &
-                               SUM( surf_lsm_h%frac(:,m) *                     &
-                                    surf_lsm_h%rrtm_asdir(:,m) ) * rmask(j,i,sr)
+                               SUM( surf_lsm_h%frac(m,:) *                     &
+                                    surf_lsm_h%rrtm_asdir(m,:) ) * rmask(j,i,sr)
                    ENDIF
                    IF ( surf_usm_h%end_index(j,i) >=                           &
@@ -1117,15 +1118,15 @@
                       m = surf_usm_h%start_index(j,i)
                       sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  +              &
-                               SUM( surf_usm_h%frac(:,m) *                     &
-                                    surf_usm_h%rrtm_aldif(:,m) ) * rmask(j,i,sr)
+                               SUM( surf_usm_h%frac(m,:) *                     &
+                                    surf_usm_h%rrtm_aldif(m,:) ) * rmask(j,i,sr)
                       sums_l(nzb,109,tn) = sums_l(nzb,109,tn)  +               &
-                               SUM( surf_usm_h%frac(:,m) *                     &
-                                    surf_usm_h%rrtm_aldir(:,m) ) * rmask(j,i,sr)
+                               SUM( surf_usm_h%frac(m,:) *                     &
+                                    surf_usm_h%rrtm_aldir(m,:) ) * rmask(j,i,sr)
                       sums_l(nzb,110,tn) = sums_l(nzb,110,tn)  +               &
-                               SUM( surf_usm_h%frac(:,m) *                     &
-                                    surf_usm_h%rrtm_asdif(:,m) ) * rmask(j,i,sr)
+                               SUM( surf_usm_h%frac(m,:) *                     &
+                                    surf_usm_h%rrtm_asdif(m,:) ) * rmask(j,i,sr)
                       sums_l(nzb,111,tn) = sums_l(nzb,111,tn)  +               &
-                               SUM( surf_usm_h%frac(:,m) *                     &
-                                    surf_usm_h%rrtm_asdir(:,m) ) * rmask(j,i,sr)
+                               SUM( surf_usm_h%frac(m,:) *                     &
+                                    surf_usm_h%rrtm_asdir(m,:) ) * rmask(j,i,sr)
                    ENDIF
 
Index: palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4440)
+++ palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4441)
@@ -21,5 +21,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Change order of dimension in surface array %frac to allow for better 
+! vectorization.
 ! 
 ! Former revisions:
@@ -1225,5 +1226,5 @@
                                           ( buildings(nb)%num_facades_per_building_h +              &
                                             buildings(nb)%num_facades_per_building_v )                !< [m2] area of total facade
-             window_area_per_facade       = surf_usm_h%frac(ind_wat_win,m)  * facade_element_area     !< [m2] window area per facade element
+             window_area_per_facade       = surf_usm_h%frac(m,ind_wat_win)  * facade_element_area     !< [m2] window area per facade element
 
              buildings(nb)%net_floor_area = buildings(nb)%vol_tot / ( buildings(nb)%height_storey )
@@ -1275,6 +1276,6 @@
              near_facade_temperature = surf_usm_h%pt_10cm(m)
              indoor_wall_window_temperature =                                  &
-                  surf_usm_h%frac(ind_veg_wall,m) * t_wall_h(nzt_wall,m)       &
-                + surf_usm_h%frac(ind_wat_win,m)  * t_window_h(nzt_wall,m)
+                  surf_usm_h%frac(m,ind_veg_wall) * t_wall_h(nzt_wall,m)       &
+                + surf_usm_h%frac(m,ind_wat_win)  * t_window_h(nzt_wall,m)
 !
 !--          Solar thermal gains. If net_sw_in larger than sun-protection 
@@ -1435,5 +1436,5 @@
                                           ( buildings(nb)%num_facades_per_building_h +              &
                                             buildings(nb)%num_facades_per_building_v )                !< [m2] area of total facade
-             window_area_per_facade       = surf_usm_v(l)%frac(ind_wat_win,m)  * facade_element_area  !< [m2] window area per facade element
+             window_area_per_facade       = surf_usm_v(l)%frac(m,ind_wat_win)  * facade_element_area  !< [m2] window area per facade element
 
              buildings(nb)%net_floor_area = buildings(nb)%vol_tot / ( buildings(nb)%height_storey )
@@ -1486,6 +1487,6 @@
              near_facade_temperature = surf_usm_v(l)%pt_10cm(m)
              indoor_wall_window_temperature =                                                       &
-                  surf_usm_v(l)%frac(ind_veg_wall,m) * t_wall_v(l)%t(nzt_wall,m)                    &
-                + surf_usm_v(l)%frac(ind_wat_win,m)  * t_window_v(l)%t(nzt_wall,m)
+                  surf_usm_v(l)%frac(m,ind_veg_wall) * t_wall_v(l)%t(nzt_wall,m)                    &
+                + surf_usm_v(l)%frac(m,ind_wat_win)  * t_window_v(l)%t(nzt_wall,m)
 !
 !--          Solar thermal gains. If net_sw_in larger than sun-protection 
